=== aiter_meta/3rdparty/composable_kernel/experimental/builder/CMakeLists.txt ===
if(BUILD_TESTING)
    add_subdirectory(test)
endif()
