=== aiter_meta/3rdparty/composable_kernel/test/batched_gemm_b_scale/CMakeLists.txt ===

add_gtest_executable(test_batched_gemm_b_scale_wmma test_batched_gemm_b_scale_wmma.cpp)
if(result EQUAL 0)
    target_link_libraries(test_batched_gemm_b_scale_wmma PRIVATE utility device_batched_gemm_b_scale_instance)
endif()
