## amd 0.2

=== debian/changelog ===
amd (1:0.2) unstable; urgency=low

  * Ooops, added dh_fixperms; closes: #133360.

 -- Philippe Troin <phil@fifi.org>  Mon, 11 Feb 2002 11:05:52 -0800

amd (1:0.1) unstable; urgency=low

  * Change woody version number from 2.3 to 3.0; closes: #111022.
  * Bumped standards-version to 3.5.5.0.
  * Added debhelper to build-depends.

 -- Philippe Troin <phil@fifi.org>  Thu, 29 Nov 2001 14:58:06 -0800

amd (1:0.0) unstable; urgency=low

  * Upgrade package; closes: #86795, #83288.

 -- Philippe Troin <phil@fifi.org>  Sun, 11 Mar 2001 18:11:51 -0800

amd (upl102-35) unstable; urgency=low

  * Recompiled for glibc 2.1.96; closes: #74869, #74665.

 -- Philippe Troin <phil@fifi.org>  Thu,  2 Nov 2000 22:44:07 -0800

amd (upl102-34) unstable; urgency=low

  * New maintainer.
  * Always add an eol to amd.master in amdconfig (Closes: #63782).

 -- Philippe Troin <phil@fifi.org>  Wed,  9 Aug 2000 14:12:55 -0700

amd (upl102-33) frozen unstable; urgency=low

  * Add missing argument to stop_amd in /etc/init.d/amd in force-reload
    target. (Closes: #56764)
  * Added Build-Depends (Standards-Version 3.1.1)

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Tue, 1 Feb 2000 10:50:29 +0100

amd (upl102-32) unstable; urgency=low

  * Fix amdconfig so that it references /usr/share/doc/examples instead
    /usr/doc. (Closes: #50957).

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Tue, 23 Nov 1999 09:45:39 +0100

amd (upl102-31) unstable; urgency=low

  * init.d script: exit with error if `hostname` doesn't return a domain
    name and `dnsdomainname` also can't tell us the domain name.
    (Closes: #47449)
  * Remove dependency on netstd, which has been broken up into smaller
    packages. After a careful check, I still can't see which of those new
    package might be needed :-) But I haven't added the netstd dependency
    myself, it's there since ancient times. (Closes: #49400)

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Tue, 9 Nov 1999 11:47:37 +0100

amd (upl102-30) unstable; urgency=HIGH

  * Another buffer overflow patch by Dan <dan@debian.org>.
  * Standards-Version: 3.0.1 (FHS changes already in last version, but
    forgot to dump up this number).

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Mon, 11 Oct 1999 10:58:05 +0200

amd (upl102-29) unstable; urgency=HIGH

  * Applied patch by Dan <dan@debian.org> for buffer overflows (Closes: #44552)
  * Converted to FHS (/usr/share/{doc,man,info}) with new debhelper.
  * Removed bashisms from debian/rules.
  
 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Tue, 14 Sep 1999 15:48:20 +0200

amd (upl102-28) unstable; urgency=low

  * Use new dh_installinfo.
  * Added @dircategory and @direntry commands to doc/amdref.texinfo (those
    weren't invented yet as the document was written, and dh_installinfo
    needs them.)
  * Modify doc/Makefile.doc and debian/rules so that doc/texinfo.tex isn't
    used (it's very outdated).
  * Also remove doc/amdref.{tps,vr}.

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Fri, 9 Jul 1999 13:18:54 +0200

amd (upl102-27) unstable; urgency=low

  * debian/rules rewritten to use debhelper.
  * Updated Standards-Version to 3.0.0 (no changes).

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Thu, 8 Jul 1999 14:13:23 +0200

amd (upl102-26) unstable; urgency=low

  * Two patches by Massimo Dal Zotto <dz@cs.unitn.it>: Fix calculation of
    net addr in wire.c and create mount point if necessary for type prog
    fses.
  * Added two example files contributed by Massimo, too: a_removable to
    mount floppy or CD-ROM, and fdmount to mount a floppy with unknown fs
    type on it.
  * Updated to Standards-Version 2.5.0.0 (no changes).

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Tue, 27 Apr 1999 13:39:22 +0200

amd (upl102-25) unstable; urgency=medium

  * Revert changed amd invocation in /etc/init.d/amd; it was plainly
    wrong. The problem described in #29738 isn't fixed by the additional
    "--", but has the same reason as #28564. So an additional "--" is
    necessary, but in /etc/amd/amd.master itself, not in the the init
    script. Unfortunately, the "--" can cause severe problems with the
    interpretation of other options.

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Thu, 11 Mar 1999 11:50:35 +0100

amd (upl102-24) unstable; urgency=low

  * Changed invocation of amd in /etc/init.d/amd to allow for options that
    start with '-'. (Fixes: #29738)
  * Add -D__NO_STRING_INLINES to CCOPTS to avoid errors with glibc2.1
    which defines some string functions as macros. Fixes part of #33058.
    (The other part of the NMU patch (gdbm-ndbm.h) is questionable, amd
    *should* be linked with libgdbm.)

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Wed, 10 Mar 1999 14:18:42 +0100

amd (upl102-23.1) frozen unstable; urgency=low

  * non maintainer, sparc only upload
  * with glibc2.1 ndbm.h is called ndbm.h not gdbm-ndbm.h
  * disable string optimization with glibc2.1 because amd comes with its
    own string functions which conflicts with glibc's

 -- Christian Meder <meder@isr.uni-stuttgart.de>  Tue,  5 Jan 1999 12:34:49 +0100

amd (upl102-23) frozen unstable; urgency=low

  * Make prerm/postinst scripts not exit with status 1 if no amd was running.
    (Fixes: #21545)
  * Fix some node connection errors in texinfo source detected by new
    makeinfo.

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Fri, 24 Apr 1998 14:02:27 +0200

amd (upl102-22) frozen unstable; urgency=low

  * Also rename manpage for fsinfo to amd-fsinfo.
  * Sparc/glibc2.1 fixes by Eric Delaunay <delaunay@lix.polytechnique.fr>:
    (fixes: #20070)
  * Initialize logfp at run time (not statically), because glibc 2.1
    doesn't suppoer this.
  * Use <endian.h> instead of <bytesex.h>.

 -- Roman Hodek <Roman.Hodek@informatik.uni-erlangen.de>  Fri, 27 Mar 1998 10:14:37 +0100

amd (upl102-21.1) frozen unstable; urgency=low


