=== debian/control ===
Source: amd
Section: net
Priority: extra
Maintainer: Philippe Troin <phil@fifi.org>
Build-Depends-Indep: debhelper (>= 2.2.0)
Standards-Version: 3.5.5.0

Package: amd
Architecture: all
Depends: am-utils
Description: Dummy package for upgrades
 In Debian 2.2 and below the BSD automounter was provided by this package.
 Starting with Debian 3.0 ("woody"), this is provided by the am-utils package.
 .
 You may remove this package at any time.
